How to get Thread Status

Navigation: »No topics above this level«

How to get Thread Status

 Return to chapter overview

Thread Status is free for commercial use. Thread Status can be downloaded for Software Verify's website at https://www.softwareverify.com/product/thread-status-monitor/.

This help manual is available in Compiled HTML Help (Windows Help files), PDF, and online.

Windows Help | https://www.softwareverify.com/documentation/chm/threadStatus.chm
PDF | https://www.softwareverify.com/documentation/pdfs/threadStatus.pdf
Online | https://www.softwareverify.com/documentation/html/threadStatus/index.html

Whilst Thread Status is free for commercial use, Thread Status is copyrighted software and is not in the public domain.

You are free to use the software at your own risk.

You are not allowed to distribute the software in any form, or to sell the software, or to host the software on a website.

Contact

Contact Software Verify at:

Software Verify Limited

Suffolk Business Park

Eldo House

Kempson Way

Bury Saint Edmunds

IP32 7AR

United Kingdom

email | sales@softwareverify.com
web | https://www.softwareverify.com
blog | https://www.softwareverify.com/blog
twitter | http://twitter.com/softwareverify

Visit our blog to read our articles on debugging techniques and tools.

Follow us on twitter to keep track of the latest software tools and updates.

Versions

There are two versions of Thread Status:

·A version for 32 bit operating systems: threadStatus.exe

·A version for 64 bit operating systems: threadStatus_x64.exe.

The 32 bit version will run on 64 bit operating systems but will only show information about 32 bit processes.

The 64 bit version will only run on 64 bit operating systems and will only show information about 64 bit processes.


What does Thread Status do?

What does Thread Status do?

 Return to chapter overview

Thread Status allows you to inspect information about each running thread in an application.

Processes

Processes are shown in the top grid. The process id and the process name are shown. You can sort the grid by clicking the appropriate column header.

By default only user processes are shown.

System processes (executables in the Windows systems directory) and services can be shown if you want to monitor one of those.

Use the three check boxes to control which types of process are shown.

Threads

Threads are shown in the bottom grid. The thread id, thread name and thread statistics are shown. You can sort the grid by clicking the appropriate column header.

Information that is displayed about each thread:

Thread id

This is the numeric identifer assigned to the thread by the Windows operating system.

Name

This is the name of the thread if the thread has been given a name using the SetThreadDescription() API. This is only available on Windows 10.

If a thread description is not available we attempt to provide a name for this thread by querying the thread's start address, and if successful we try to turn this start address into a useful symbolic name. Depending on the process and the operating system these operations may success, in which we display a name, or they may fail in which case we display nothing.

Status

This is the state the thread is in. The possible values are:

StateInitialised

StateReady

StateRunning

StateStandby

StateTerminated

StateWait

StateTransition

StateUnknown

Reason

This is the reason the thread is in the state it is in. The possible values are:

Executive

FreePage

PageIn

PoolAllocation

DelayExecution

Suspended

UserRequest

WrExecutive

WrFreePage

WrPageIn

WrPoolAllocation

WrDelayExecution

WrSuspended

WrUserRequest

WrEventPair

WrQueue

WrLpcReceive

WrLpcReply

WrVirtualMemory

WrPageOut

WrRendezvous

WrSpare1

WrSpare2

WrSpare3

WrSpare4

WrSpare5

WrSpare6

WrKernel

Context switches

This is the number of context switches this thread has been involved in.

Thread Priority

This is the thread scheduling priority used by the operating system to decide which thread runs next.

Wait Time

This is how long the thread has been waiting.

Thread Time

This is how long the thread has been running.

Thread Delta

This is the change in the thread run time since the last sample.

CPU usage

This is how much CPU time the thread is getting relative to the other threads.


Menu

Menu

The main menu contains three menus, File, Software Updates and Help.


File

Navigation: Menu >

File

 Return to chapter overview

The File menu controls which process will be monitored.

File menu instructionStep Monitor a Process... instructionStep displays the process chooser to allow you to choose which process to monitor.

File menu instructionStep Stop Monitoring instructionStep stops monitoring the process and clears the display.

File menu instructionStep Exit instructionStep closes Thread Status.


Software Updates

Navigation: Menu >

Software Updates

 Return to chapter overview

The Software Updates menu controls how often software updates are downloaded.

If you've been notified of a new software release to Thread Status or just want to see if there's a new version, this feature makes it easy to update.

menu Software Updates menu instructionStep Check for software updates instructionStep checks for updates and shows the software update dialog if any exist

An internet connection is needed to be able to make contact with our servers.

note Before updating the software, close the help manual, and end any active session by closing target programs.

If no updates are available, you'll just see this message:

Software Update dialog

If a software update is available for Thread Status you'll see the software update dialog.

·Download and install instructionStep downloads the update, showing progress

Once the update has downloaded, Thread Status will close, run the installer, and restart.

You can stop the download at any time, if necessary.

·Don't download... instructionStep Doesn't download, but you'll be prompted for it again next time you start Thread Status

·Skip this version... instructionStep Doesn't download the update and doesn't bother you again until there's an even newer update

·Software update options... instructionStep edit the software update schedule

Problems downloading or installing?

If for whatever reason, automatic download and installation fails to complete:

·Download the latest installer manually from the software verify website.

Make some checks for possible scenarios where files may be locked by Thread Status as follows:

·Ensure Thread Status and its help manual is also closed

·Ensure any error dialogs from the previous installation are closed

You should now be ready to run the new version.

Software update schedule

Thread Status can automatically check to see if a new version of Thread Status is available for downloading.

menu Software Updates menu instructionStep Configure software updates instructionStep shows the software update schedule dialog

The update options are:

·never check for updates

·check daily (the default)

·check weekly

·check monthly

The most recent check for updates is shown at the bottom.

Software update directory

It’s important to be able to specify where software updates are downloaded to because of potential security risks that may arise from allowing the TMP directory to be executable. For example, to counteract security threats it's possible that account ownership permissions or antivirus software blocks program execution directly from the TMP directory.

The TMP directory is the default location but if for whatever reason you're not comfortable with that, you can specify your preferred download directory. This allows you to set permissions for TMP to deny execute privileges if you wish.

menu Software Updates menu instructionStep Set software update directory instructionStep shows the Software update download directory dialog

An invalid directory will show the path in red and will not be accepted until a valid folder is entered.

Example reasons for invalid directories include:

·the directory doesn't exist

·the directory doesn't have write privilege (update can't be downloaded)

·the directory doesn't have execute privilege (downloaded update can't be run)

note When modifying the download directory, you should ensure the directory will continue to be valid. Updates may no longer occur if the download location is later invalidated.

·Reset instructionStep reverts the download location to the user's TMP directory

The default location is c:\users\[username]\AppData\Local\Temp


Help

Navigation: Menu >

Help

 Return to chapter overview

The Help menu controls displaying this help document and displaying information about Thread Status.

Help menu instructionStep About Thread Status... instructionStep displays information about Thread Status.

Help menu instructionStep Readme and Version History... instructionStep displays the readme and version history.

Help menu instructionStep Help Topics... instructionStep displays this help file.

Help menu instructionStep Help PDF... instructionStep displays this help file in PDF format.

Help menu instructionStep Help on softwareverify.com... instructionStep display the Software Verify documentation web page where you can view online documentation or download compiled HTML Help and PDF help documents.

Help menu instructionStep Blog... instructionStep display the Software Verify blog.

Help menu instructionStep Library... instructionStep display the Software Verify library - our best blog articles grouped by related topics.

Help menu instructionStep Contact customer support... instructionStep displays the options for contacting customer support.

Click a link to contact customer support.

Help menu instructionStep How do I?... instructionStep displays the options for asking us how to do a particular task.


The user interface

The user interface

The Thread Status user interface displays the threads in the selected process:

Thread Controls

Refresh

You can update the display manually by clicking the Refresh button. This is useful if you have disabled automatic updates via the the Update Interval control.

Update Interval

You can change how frequently the display is updated using the Update Interval control. The default is to update every one second.

Hide uninteresting threads

When this is selected, threads that are known to be Microsoft worker threads are hidden.


Process chooser dialog

Process chooser dialog

The Attach to process dialog allows you to choose a user process, system process or service to attach to.

·System processes / Services / User processes instructionStep show either of system or services or user processes in the list, or both

·Full path instructionStep shows the full path to the process executable in the list

·Image Name instructionStep shows the short program name without path

·Refresh instructionStep update the list with currently running processes

·Attach instructionStep attach to the selected process and start collecting debug events

Clicking on the headers of the list will sort them by ID or by name using the full name or short name, depending on what's displayed.